"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Component_1 = __importDefault(require("../share/Component"));
var each_1 = __importDefault(require("licia/each"));
var _1 = __importDefault(require("licia/$"));
var h_1 = __importDefault(require("licia/h"));
var map_1 = __importDefault(require("licia/map"));
var filter_1 = __importDefault(require("licia/filter"));
var stripIndent_1 = __importDefault(require("licia/stripIndent"));
var toArr_1 = __importDefault(require("licia/toArr"));
var MutationObserver_1 = __importDefault(require("licia/MutationObserver"));
var contain_1 = __importDefault(require("licia/contain"));
var highlight_1 = __importDefault(require("licia/highlight"));
var truncate_1 = __importDefault(require("licia/truncate"));
var last_1 = __importDefault(require("licia/last"));
var escape_1 = __importDefault(require("licia/escape"));
var trim_1 = __importDefault(require("licia/trim"));
var every_1 = __importDefault(require("licia/every"));
var hotkey_1 = __importDefault(require("licia/hotkey"));
var util_1 = require("../share/util");
var emptyHighlightStyle = {
    comment: '',
    string: '',
    number: '',
    keyword: '',
    operator: '',
};
var DomViewer = (function (_super) {
    __extends(DomViewer, _super);
    function DomViewer(container, options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, container, { compName: 'dom-viewer' }, options) || this;
        _this.isExpanded = false;
        _this.childNodes = [];
        _this.childNodeDomViewers = [];
        _this.expand = function () {
            if (!_this.isExpandable() || _this.isExpanded) {
                return;
            }
            _this.isExpanded = true;
            _this.renderExpandTag();
            _this.renderChildNodes();
        };
        _this.collapse = function () {
            if (!_this.isExpandable() || !_this.isExpanded) {
                return;
            }
            _this.isExpanded = false;
            _this.renderCollapseTag();
        };
        _this.toggle = function () {
            if (_this.isExpanded) {
                _this.collapse();
            }
            else {
                _this.expand();
            }
        };
        _this.onKeyRight = function () {
            if (_this.isExpanded) {
                _this.childNodeDomViewers[0].select();
            }
            else {
                _this.expand();
            }
        };
        _this.onKeyLeft = function () {
            var _a;
            if (_this.isExpanded) {
                _this.collapse();
            }
            else {
                (_a = _this.options.parent) === null || _a === void 0 ? void 0 : _a.select();
            }
        };
        _this.onKeyDown = function () {
            var options = _this.options;
            if (_this.isExpanded) {
                _this.childNodeDomViewers[0].select();
                return;
            }
            var parent = options.parent;
            if (!parent) {
                return;
            }
            if (options.isEndTag) {
                parent = parent.getOption('parent');
                if (!parent) {
                    return;
                }
                var childNodes = parent.childNodes, childNodeDomViewers = parent.childNodeDomViewers, endTagDomViewer = parent.endTagDomViewer;
                var idx = childNodes.indexOf(options.node);
                if (childNodes[idx + 1]) {
                    childNodeDomViewers[idx + 1].select();
                }
                else if (endTagDomViewer) {
                    endTagDomViewer.select();
                }
            }
            else {
                var childNodeDomViewers = parent.childNodeDomViewers, endTagDomViewer = parent.endTagDomViewer;
                var idx = childNodeDomViewers.indexOf(_this);
                if (childNodeDomViewers[idx + 1]) {
                    childNodeDomViewers[idx + 1].select();
                }
                else if (endTagDomViewer) {
                    endTagDomViewer.select();
                }
            }
        };
        _this.onKeyUp = function () {
            var _a;
            var options = _this.options;
            var parent = options.parent;
            if (!parent) {
                return;
            }
            var domViewer;
            if (options.isEndTag) {
                domViewer = (0, last_1.default)(parent.childNodeDomViewers);
            }
            else {
                var idx = parent.childNodeDomViewers.indexOf(_this);
                if (idx < 1) {
                    parent.select();
                }
                else {
                    domViewer = parent.childNodeDomViewers[idx - 1];
                }
            }
            if (domViewer) {
                if (domViewer.isExpanded) {
                    (_a = domViewer.endTagDomViewer) === null || _a === void 0 ? void 0 : _a.select();
                }
                else {
                    domViewer.select();
                }
            }
        };
        _this.initOptions(options, {
            node: document.documentElement,
            parent: null,
            isEndTag: false,
            rootContainer: container,
            rootDomViewer: _this,
            ignore: function () { return false; },
            hotkey: true,
        });
        _this.isShadowRoot = isShadowRoot(_this.options.node);
        _this.initTpl();
        _this.bindEvent();
        if (!_this.options.isEndTag) {
            _this.initObserver();
        }
        return _this;
    }
    DomViewer.prototype.select = function (node) {
        var _a = this, c = _a.c, options = _a.options;
        if (!node || (node && options.node === node)) {
            if (this.$tag.hasClass(c('selected'))) {
                return;
            }
            (0, _1.default)(this.options.rootContainer)
                .find(c('.selected'))
                .rmClass(c('selected'))
                .rmAttr('tabindex');
            this.$tag.attr('tabindex', '0').get(0).focus();
            this.$tag.addClass(c('selected'));
            options.rootDomViewer.emit('select', options.node);
            return;
        }
        if (node.nodeType !== Node.ELEMENT_NODE) {
            return;
        }
        var childNode = node;
        var curNode = node.parentElement;
        while (curNode) {
            if (curNode === options.node) {
                this.expand();
                var childNodeDomViewer = this.childNodeDomViewers[this.childNodes.indexOf(childNode)];
                childNodeDomViewer.select(node);
                break;
            }
            childNode = curNode;
            curNode = curNode.parentElement;
        }
    };
    DomViewer.prototype.attach = function () {
        this.container.appendChild(this.$tag.get(0));
        if (this.$children) {
            this.container.appendChild(this.$children.get(0));
        }
    };
    DomViewer.prototype.isAttached = function () {
        return !!this.$tag.get(0).parentNode;
    };
    DomViewer.prototype.detach = function () {
        this.$tag.remove();
        if (this.$children) {
            this.$children.remove();
        }
    };
    DomViewer.prototype.destroy = function () {
        var c = this.c;
        if (this.$tag.hasClass(c('selected'))) {
            this.options.rootDomViewer.emit('deselect');
        }
        this.detach();
        if (this.observer) {
            this.observer.disconnect();
        }
        this.destroySubComponents();
        if (this.options.rootDomViewer === this) {
            this.$container
                .rmClass("luna-dom-viewer")
                .rmClass(c("platform-".concat((0, util_1.getPlatform)())))
                .rmClass(c("theme-".concat(this.options.theme)));
        }
        this.emit('destroy');
        this.removeAllListeners();
    };
    DomViewer.prototype.renderExpandTag = function () {
        var _a = this, $tag = _a.$tag, c = _a.c;
        var node = this.options.node;
        if (!this.isShadowRoot) {
            $tag.html(this.renderHtmlTag(__assign(__assign({}, getHtmlTagData(node)), { hasTail: false, hasToggleButton: true })));
        }
        $tag.addClass(c('expanded'));
        this.$children.rmClass(c('hidden'));
    };
    DomViewer.prototype.renderCollapseTag = function () {
        var _a = this, $tag = _a.$tag, c = _a.c;
        var node = this.options.node;
        this.$children.addClass(c('hidden'));
        if (!this.isShadowRoot) {
            this.$tag.html(this.renderHtmlTag(__assign(__assign({}, getHtmlTagData(node)), { hasTail: true, hasToggleButton: true })));
        }
        $tag.rmClass(c('expanded'));
    };
    DomViewer.prototype.initObserver = function () {
        var _this = this;
        this.observer = new MutationObserver_1.default(function (mutations) {
            (0, each_1.default)(mutations, function (mutation) {
                _this.handleMutation(mutation);
            });
        });
        this.observer.observe(this.options.node, {
            attributes: true,
            childList: true,
            characterData: true,
        });
    };
    DomViewer.prototype.handleMutation = function (mutation) {
        var _a = this, $tag = _a.$tag, c = _a.c;
        var _b = this.options, node = _b.node, ignore = _b.ignore;
        if ((0, contain_1.default)(['attributes', 'childList'], mutation.type)) {
            if (mutation.type === 'childList') {
                if ((0, every_1.default)(mutation.addedNodes, ignore) &&
                    (0, every_1.default)(mutation.removedNodes, ignore)) {
                    return;
                }
                this.renderChildNodes();
            }
            if (this.isExpandable()) {
                this.isExpanded ? this.renderExpandTag() : this.renderCollapseTag();
            }
            else {
                this.$children.addClass(c('hidden'));
                this.isExpanded = false;
                if (this.isShadowRoot) {
                    $tag.html(this.renderShadowRoot(false));
                }
                else {
                    $tag.html(this.renderHtmlTag(__assign(__assign({}, getHtmlTagData(node)), { hasTail: false })));
                }
            }
        }
        else if (mutation.type === 'characterData') {
            if (node.nodeType === Node.TEXT_NODE) {
                $tag.html(this.renderTextNode(node));
            }
            else if (node.nodeType === Node.COMMENT_NODE) {
                $tag.html(this.renderHtmlComment(node.nodeValue));
            }
        }
    };
    DomViewer.prototype.bindEvent = function () {
        var _this = this;
        var _a = this, c = _a.c, $tag = _a.$tag;
        var node = this.options.node;
        if (node.nodeType === Node.ELEMENT_NODE || this.isShadowRoot) {
            $tag.on('click', c('.toggle'), function (e) {
                e.stopPropagation();
                _this.toggle();
            });
        }
        if (util_1.hasTouchSupport) {
            $tag.on('click', function () { return _this.select(); });
        }
        else {
            $tag.on('mousedown', function () { return _this.select(); });
        }
        if (this.options.hotkey) {
            var options = { element: $tag.get(0) };
            hotkey_1.default.on('right', options, this.onKeyRight);
            hotkey_1.default.on('left', options, this.onKeyLeft);
            hotkey_1.default.on('down', options, this.onKeyDown);
            hotkey_1.default.on('up', options, this.onKeyUp);
        }
    };
    DomViewer.prototype.isExpandable = function () {
        var node = this.options.node;
        if (node.nodeType !== Node.ELEMENT_NODE && !this.isShadowRoot) {
            return false;
        }
        return this.getChildNodes().length > 0;
    };
    DomViewer.prototype.getChildNodes = function () {
        var _a = this.options, rootContainer = _a.rootContainer, ignore = _a.ignore;
        var node = this.options.node;
        var childNodes = (0, toArr_1.default)(node.childNodes);
        childNodes = (0, filter_1.default)(childNodes, function (child) {
            if (child.nodeType === Node.TEXT_NODE ||
                child.nodeType === Node.COMMENT_NODE) {
                var value = child.nodeValue;
                if ((0, trim_1.default)(value) === '') {
                    return false;
                }
            }
            return child !== rootContainer && !ignore(child);
        });
        if (node.shadowRoot) {
            childNodes.unshift(node.shadowRoot);
        }
        else if (node.chobitsuShadowRoot) {
            childNodes.unshift(node.chobitsuShadowRoot);
        }
        return childNodes;
    };
    DomViewer.prototype.initTpl = function () {
        var _a = this, container = _a.container, c = _a.c;
        var _b = this.options, node = _b.node, isEndTag = _b.isEndTag;
        var $tag = (0, _1.default)((0, h_1.default)('li'));
        $tag.addClass(c('tree-item'));
        this.$tag = $tag;
        if (isEndTag) {
            $tag.html(c("<span class=\"html-tag\" style=\"margin-left: -15px;\">&lt;<span class=\"tag-name\">/".concat(node.tagName.toLocaleLowerCase(), "</span>&gt;</span><span class=\"selection\"></span>")));
        }
        else if (node.nodeType === Node.ELEMENT_NODE) {
            var isExpandable = this.isExpandable();
            var data = __assign(__assign({}, getHtmlTagData(node)), { hasTail: isExpandable, hasToggleButton: isExpandable });
            $tag.html(this.renderHtmlTag(data));
        }
        else if (isShadowRoot(node)) {
            var isExpandable = this.isExpandable();
            $tag.html(this.renderShadowRoot(isExpandable));
        }
        else if (node.nodeType === Node.TEXT_NODE) {
            $tag.html(this.renderTextNode(node));
        }
        else if (node.nodeType === Node.COMMENT_NODE) {
            var value = node.nodeValue;
            if (value.trim() === '')
                return;
            $tag.html(this.renderHtmlComment(value));
        }
        else {
            return;
        }
        container.appendChild($tag.get(0));
        if (node.nodeType === node.ELEMENT_NODE || this.isShadowRoot) {
            var $children = (0, _1.default)((0, h_1.default)('ul'));
            $children.addClass([c('children'), c('hidden')]);
            container.appendChild($children.get(0));
            this.$children = $children;
        }
    };
    DomViewer.prototype.renderChildNodes = function () {
        var _this = this;
        var node = this.options.node;
        var _a = this.options, rootContainer = _a.rootContainer, ignore = _a.ignore, rootDomViewer = _a.rootDomViewer;
        var $container = this.$children;
        var container = $container.get(0);
        var oldChildNodes = this.childNodes;
        var oldChildNodeDomViewers = this.childNodeDomViewers;
        (0, each_1.default)(oldChildNodeDomViewers, function (domViewer) {
            domViewer.detach();
            _this.removeSubComponent(domViewer);
        });
        if (this.endTagDomViewer) {
            this.endTagDomViewer.detach();
        }
        var childNodes = this.getChildNodes();
        this.childNodes = childNodes;
        var childNodeDomViewers = [];
        this.childNodeDomViewers = childNodeDomViewers;
        (0, each_1.default)(childNodes, function (node, idx) {
            var pos = oldChildNodes.indexOf(node);
            var domViewer;
            if (pos > -1) {
                domViewer = oldChildNodeDomViewers[pos];
            }
            else {
                domViewer = new DomViewer(container, {
                    node: node,
                    parent: _this,
                    rootContainer: rootContainer,
                    rootDomViewer: rootDomViewer,
                    ignore: ignore,
                });
            }
            domViewer.attach();
            childNodeDomViewers[idx] = domViewer;
            _this.addSubComponent(domViewer);
        });
        (0, each_1.default)(oldChildNodeDomViewers, function (domViewer) {
            if (!domViewer.isAttached()) {
                domViewer.destroy();
            }
        });
        if (node && !this.isShadowRoot) {
            if (this.endTagDomViewer) {
                this.endTagDomViewer.attach();
            }
            else {
                this.endTagDomViewer = new DomViewer(container, {
                    node: node,
                    parent: this,
                    isEndTag: true,
                    rootContainer: rootContainer,
                    rootDomViewer: rootDomViewer,
                    ignore: ignore,
                });
                this.addSubComponent(this.endTagDomViewer);
            }
        }
    };
    DomViewer.prototype.renderHtmlTag = function (data) {
        var attributes = (0, map_1.default)(data.attributes, function (attribute) {
            var name = attribute.name, value = attribute.value, isLink = attribute.isLink;
            return "<span class=\"attribute\">\n          <span class=\"attribute-name\">".concat((0, escape_1.default)(name), "</span>").concat(value
                ? "=\"<span class=\"attribute-value".concat(isLink ? ' attribute-underline' : '', "\">").concat((0, escape_1.default)(value), "</span>\"")
                : '', "</span>");
        }).join('');
        var tail = '';
        if (data.hasTail) {
            tail = "".concat(data.hasTail ? '…' : '', "<span class=\"html-tag\">&lt;<span class=\"tag-name\">/").concat(data.tagName, "</span>&gt;</span>");
        }
        else if (!this.isExpandable()) {
            tail = "<span class=\"html-tag\">&lt;<span class=\"tag-name\">/".concat(data.tagName, "</span>&gt;</span>");
        }
        return this.c((0, stripIndent_1.default)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      ", "\n      <span class=\"html-tag\">&lt;<span class=\"tag-name\">", "</span>", "&gt;</span>", "\n      <span class=\"selection\"></span>"], ["\n      ", "\n      <span class=\"html-tag\">&lt;<span class=\"tag-name\">", "</span>", "&gt;</span>", "\n      <span class=\"selection\"></span>"])), data.hasToggleButton ? this.renderToggle() : '', data.tagName, attributes, tail));
    };
    DomViewer.prototype.renderTextNode = function (node) {
        var c = this.c;
        var value = node.nodeValue;
        var parent = node.parentElement;
        var prepend = '<span class="text-node">';
        var append = '</span><span class="selection"></span>';
        if (parent && value.length < 10000) {
            if (parent.tagName === 'STYLE') {
                return c("".concat(prepend).concat((0, highlight_1.default)(value, 'css', emptyHighlightStyle)).concat(append));
            }
            else if (parent.tagName === 'SCRIPT') {
                return c("".concat(prepend).concat((0, highlight_1.default)(value, 'js', emptyHighlightStyle)).concat(append));
            }
        }
        return c("\"".concat(prepend).concat((0, escape_1.default)((0, truncate_1.default)(value, 10000, {
            separator: ' ',
            ellipsis: '…',
        }))).concat(append, "\""));
    };
    DomViewer.prototype.renderHtmlComment = function (value) {
        return this.c("<span class=\"html-comment\">&lt;!-- ".concat((0, escape_1.default)(value), " --&gt;</span><span class=\"selection\"></span>"));
    };
    DomViewer.prototype.renderShadowRoot = function (hasToggle) {
        var node = this.options.node;
        return this.c((0, stripIndent_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      ", "\n      <span class=\"shadow-root\">#shadow-root (", ")</span>\n      <span class=\"selection\"></span>"], ["\n      ", "\n      <span class=\"shadow-root\">#shadow-root (", ")</span>\n      <span class=\"selection\"></span>"])), hasToggle ? this.renderToggle() : '', node.mode));
    };
    DomViewer.prototype.renderToggle = function () {
        return '<div class="toggle "><span class="icon icon-caret-right"></span><span class="icon icon-caret-down"></span></div>';
    };
    return DomViewer;
}(Component_1.default));
exports.default = DomViewer;
function getHtmlTagData(el) {
    var ret = {
        tagName: '',
        attributes: [],
    };
    ret.tagName = el.tagName.toLocaleLowerCase();
    var attributes = [];
    (0, each_1.default)(el.attributes, function (attribute) {
        var name = attribute.name, value = attribute.value;
        attributes.push({
            name: name,
            value: value,
            isLink: isUrlAttribute(el, name),
        });
    });
    ret.attributes = attributes;
    return ret;
}
function isUrlAttribute(el, name) {
    var tagName = el.tagName;
    if (tagName === 'SCRIPT' ||
        tagName === 'IMAGE' ||
        tagName === 'VIDEO' ||
        tagName === 'AUDIO') {
        if (name === 'src')
            return true;
    }
    if (tagName === 'LINK') {
        if (name === 'href')
            return true;
    }
    return false;
}
function isShadowRoot(node) {
    if (window.ShadowRoot) {
        return node instanceof ShadowRoot;
    }
    return false;
}
if (typeof module !== 'undefined') {
    (0, util_1.exportCjs)(module, DomViewer);
}
var templateObject_1, templateObject_2;
