import Component, { IComponentOptions } from '../share/Component';
import types from 'licia/types';
export interface IOptions extends IComponentOptions {
    node?: ChildNode;
    ignore?: types.AnyFn;
    hotkey?: boolean;
    parent?: DomViewer | null;
    isEndTag?: boolean;
    rootContainer?: HTMLElement;
    rootDomViewer?: DomViewer;
}
export default class DomViewer extends Component<IOptions> {
    isExpanded: boolean;
    childNodes: ChildNode[];
    childNodeDomViewers: DomViewer[];
    endTagDomViewer?: DomViewer;
    private $tag;
    private $children;
    private observer;
    private isShadowRoot;
    constructor(container: HTMLElement, options?: IOptions);
    select(node?: ChildNode): void;
    attach(): void;
    isAttached(): boolean;
    detach(): void;
    expand: () => void;
    collapse: () => void;
    toggle: () => void;
    destroy(): void;
    private renderExpandTag;
    private renderCollapseTag;
    private initObserver;
    private handleMutation;
    private bindEvent;
    private onKeyRight;
    private onKeyLeft;
    private onKeyDown;
    private onKeyUp;
    private isExpandable;
    private getChildNodes;
    private initTpl;
    private renderChildNodes;
    private renderHtmlTag;
    private renderTextNode;
    private renderHtmlComment;
    private renderShadowRoot;
    private renderToggle;
}
